﻿using System;

namespace NMA.Domain.Model
{
    using NMA.Domain.Shared;

    public interface INews : IEntity<INews>
    {
        string Title { get; set; }

        string ShortDescription { get; set; }

        string Content { get; set; }

        bool IsPublish { get; set; }

        DateTime PublishedDate { get; set; }

        string PublishedPerson { get; set; }

        int NumberOfView { get; set; }

        byte[] Image { get; set; }

        ICategory Category { get; set; }

        IPoll Poll { get; set; }

        string CreatedUser { get; set; }

        string UpdatedUser { get; set; }

        void AssignPoll(IPoll poll);

        void AssignCategory(ICategory cat);
    }
}