﻿namespace NMA.Infrastructure.NHibernate.CriteriaExpression.Category.SearchCategory.Responsibility
{
    using NMA.Domain.Model.Contract;

    internal class IdAndNameAndCreatedDateSearch : SearchCategoryTypeFinder
    {
        public override SearchCategoryCriteriaType GetSearchCategoryType(CategorySearchCriteria model)
        {
            if (model.Id.CompareTo(null) != 0 && !string.IsNullOrEmpty(model.Name)
                && string.IsNullOrEmpty(model.CreatedUser) && model.CreatedDate != null)
            {
                return SearchCategoryCriteriaType.Id | SearchCategoryCriteriaType.Name | SearchCategoryCriteriaType.CreatedDate;
            }
            else
                if (Finder != null)
                    return Finder.GetSearchCategoryType(model);

            return SearchCategoryCriteriaType.All;
        }
    }
}