﻿using System;

namespace NMA.Infrastructure.NHibernate.DomainObject
{
    using NMA.Domain.Shared;
    using NMA.Domain.Model;
    using NMA.Infrastructure.DBC;

    public class Audit : BaseEntity<IAudit>, IAudit
    {
        public virtual string UserName { get; set; }

        public virtual string UserAction { get; set; }

        public virtual DateTime DateEvent { get; set; }

        public override bool SameIdentityAs(IAudit other)
        {
            Check.Assert(other == null, "Audit is null");

            return this.Id == other.Id;
        }
    }
}