﻿using StructureMap.Configuration.DSL;
using System.Web.Security;

namespace NMA.Web.Core.WebRegistry
{
    using NMA.Web.Areas.Admin.Models.Service;
    using NMA.Web.Areas.Admin.Models.Service.Impl;
    using NMA.Infrastructure.Configuration;
    using NMA.Web.Core.PathUtility;
    using NMA.Web.Core.Provider.Membership;
    using NMA.Application;
    using NMA.Domain.Model.Service.Application;

    public class WebComponentRegistry : Registry
    {
        public WebComponentRegistry()
        {
            // register all facades at here
            For<IResourceFacade>().Use<ResourceFacade>();

            For<IMembershipService>().Use<AccountMembershipService>();
            For<IFormsAuthenticationService>().Use<FormsAuthenticationService>();
            For<MembershipProvider>().Use<NMAMembershipProvider>();
            For<IConfigurationManager>().Use<ConfigurationManagerWrapper>();
            For<IResolvePath>().Use<VirtualPathUtilityWrapper>();
        }
    }
}